## Create attribute

### cURL

```
curl --request POST \
  --url https://live.copilot.fabric.inc/api-offers/attributes \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \
  --data '
{
  "name": "Brand",
  "values": [\
    "CHS",\
    "SOMA",\
    "WHBM"\
  ]
}
'
```

```python
import requests

url = "https://live.copilot.fabric.inc/api-offers/attributes"

payload = {
    "name": "Brand",
    "values": ["CHS", "SOMA", "WHBM"]
}
headers = {
    "x-site-context": "<x-site-context>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

```javascript
const options = {
  method: 'POST',
  headers: {
    'x-site-context': '<x-site-context>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({name: 'Brand', values: ['CHS', 'SOMA', 'WHBM']})
};

fetch('https://live.copilot.fabric.inc/api-offers/attributes', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

```php


```

### Response

#### Success (201)

```json
{
  "_id": "614b58924e92f6861ac9d43b",
  "attributeId": 100002,
  "name": "Brand",
  "values": [
    "CHS",
    "SOMA",
    "WHBM"
  ],
  "deleted": false,
  "createdAt": "2020-12-14T12:15:43.646Z",
  "updatedAt": "2021-12-14T12:15:43.646Z"
}
```

#### Conflict (400)

```json
{
  "code": "ATTRIBUTE_NAME_EXISTS",
  "message": "The attribute name already exists."
}
```

#### Server Error (500)

```json
{
  "code": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error."
}
```

### Authorizations

Authorization  
string  
header  
required  
Bearer authentication header of the form `Bearer <token>`, where `<token>` is your auth token.

### Headers

- `x-site-context`  
string  
required  
The `x-site-context` header is a JSON object that contains information about the source you wish to pull from. The mandatory `account` is the 24 character identifier found in Copilot. The `channel` (Sales channel ID), `stage` (environment name), and `date` attributes can be used to further narrow the scope of your data source.

Example:

```json
{"date": "2023-01-01T00:00:00.000Z", "channel": 12, "account": "1234abcd5678efgh9ijklmno","stage":"production"}
```

### Body

- `name`  
string  
required  
The attribute name.

Example:

```json
"Brand"
```

- `values`  
string[]  
required  
The attribute values corresponding to the `name`.

Example:

```json
["CHS", "SOMA", "WHBM"]
```

### Response Fields

- `_id`  
string  
A 24-character system-generated attribute ID.

Example:

```json
"614b58924e92f6861ac9d43b"
```

- `attributeId`  
number  
A unique identifier of the attribute, for external use.

Example:

```json
100002
```

- `name`  
string  
The attribute name.

Example:

```json
"Brand"
```

- `values`  
string[]  
The attribute values corresponding to the `name`.

Example:

```json
["CHS", "SOMA", "WHBM"]
```

- `deleted`  
boolean  
A flag indicating the deletion status of the attribute. Set it to `true` to indicate the attribute is deleted and `false` to indicate otherwise.

Example:

```json
false
```

- `createdAt`  
date-time  
The time of attribute creation, in UTC format.

Example:

```json
"2020-12-14T12:15:43.646Z"
```

- `updatedAt`  
date-time  
The time when the attribute was last updated, in UTC format.

Example:

```json
"2021-12-14T12:15:43.646Z"
```
